cmake_minimum_required(VERSION 3.0)

set(PLATFORM_DIR "${CMAKE_CURRENT_LIST_DIR}")

if ("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "aarch64")
    set(ARCH_DIR "arm64")
elseif ("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "AMD64|x86_64")
    if("${CMAKE_SIZEOF_VOID_P}" STREQUAL "4")
        set(ARCH_DIR "x86")
    elseif ("${CMAKE_SIZEOF_VOID_P}" STREQUAL "8")
        set(ARCH_DIR "x64")
    endif ()
else ()
    message(FATAL_ERROR "Unable to determine CPU architecture")
endif ()

if (UNIX)
    find_program(LSB_RELEASE_EXEC lsb_release)
    execute_process(COMMAND ${LSB_RELEASE_EXEC} -d OUTPUT_VARIABLE LSB_RELEASE_DESC OUTPUT_STRIP_TRAILING_WHITESPACE)

    if (LSB_RELEASE_DESC MATCHES "Ubuntu")
        set(PLATFORM_DIR "${CMAKE_CURRENT_LIST_DIR}/ubuntu16_04/gcc5_4_0/${ARCH_DIR}")
    elseif (LSB_RELEASE_DESC MATCHES "CentOS")
        set(PLATFORM_DIR "${CMAKE_CURRENT_LIST_DIR}/centos7/gcc7_2_1/${ARCH_DIR}")
    endif ()
elseif (WIN32)
    set(PLATFORM_DIR "${CMAKE_CURRENT_LIST_DIR}/windows/vc142/${ARCH_DIR}")
endif ()

function(add_imported_lib PLATFORM_DIR LIB VERSION)
    message(STATUS "Adding library '${LIB}'. Reference the library using the TARGET '${LIB}'")
    
    if (WIN32)        
        set(DEBUG_LIB_NAME "${LIB}${VERSION}d")        
        set(RELEASE_LIB_NAME "${LIB}${VERSION}")
    else ()        
        set(DEBUG_LIB_NAME "${LIB}")
        set(RELEASE_LIB_NAME "${LIB}")
    endif ()    
    
    add_library("${LIB}" STATIC IMPORTED GLOBAL)
    set_property(TARGET "${LIB}" APPEND PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_LIST_DIR}/include")
    set_target_properties("${LIB}" PROPERTIES IMPORTED_LOCATION_RELEASE "${PLATFORM_DIR}/release/${CMAKE_STATIC_LIBRARY_PREFIX}${RELEASE_LIB_NAME}${CMAKE_STATIC_LIBRARY_SUFFIX}")
    set_target_properties("${LIB}" PROPERTIES IMPORTED_LOCATION_DEBUG "${PLATFORM_DIR}/debug/${CMAKE_STATIC_LIBRARY_PREFIX}${DEBUG_LIB_NAME}${CMAKE_STATIC_LIBRARY_SUFFIX}")
endfunction(add_imported_lib)

add_imported_lib("${PLATFORM_DIR}" "opencv_calib3d" "343")
add_imported_lib("${PLATFORM_DIR}" "opencv_core" "343")
add_imported_lib("${PLATFORM_DIR}" "opencv_dnn" "343")
add_imported_lib("${PLATFORM_DIR}" "opencv_features2d" "343")
add_imported_lib("${PLATFORM_DIR}" "opencv_flann" "343")
add_imported_lib("${PLATFORM_DIR}" "opencv_highgui" "343")
add_imported_lib("${PLATFORM_DIR}" "opencv_imgcodecs" "343")
add_imported_lib("${PLATFORM_DIR}" "opencv_imgproc" "343")
add_imported_lib("${PLATFORM_DIR}" "opencv_videoio" "343")

add_imported_lib("${PLATFORM_DIR}" "IlmImf" "")
add_imported_lib("${PLATFORM_DIR}" "ittnotify" "")
add_imported_lib("${PLATFORM_DIR}" "libjasper" "")
add_imported_lib("${PLATFORM_DIR}" "libjpeg-turbo" "")
add_imported_lib("${PLATFORM_DIR}" "libpng" "")
add_imported_lib("${PLATFORM_DIR}" "libprotobuf" "")
add_imported_lib("${PLATFORM_DIR}" "libtiff" "")
